/*
 * Copyright: (c) TBEE.ORG
 * Version: $Revision: 1.15 $
 * Modified:$Date: 2007/06/25 20:04:12 $
 * By:$Author: toeukpap $
 */
package nl.reinders.bm;

import java.util.ArrayList;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class BMTestToplink
{

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		System.out.println( "java.vm.version=" + System.getProperty("java.vm.version"));
		System.getProperties().put("org.xml.sax.driver", "org.apache.xerces.parsers.SAXParser");
		
		Map<String, Object> cfg = BM.getEntityManagerFactorySettings(com.informix.jdbc.IfxDriver.class, "jdbc:informix-sqli://toeu_reinders:1526/reinders:INFORMIXSERVER=ol_vmware;DB_LOCALE=en_us.utf8", "user", "user");
		EntityManagerFactory lEntityManagerFactory = Persistence.createEntityManagerFactory("reinders", cfg);

		EntityManager lEntityManager = lEntityManagerFactory.createEntityManager();
		org.tbee.util.jpa.EntityManagerFinderSingleton.register(); 
		org.tbee.util.jpa.EntityManagerFinderSingleton.setEntityManager(lEntityManager); 
		
		// find the original
		Standversion lImportFromStandversion = Standversion.findByStandidVersion("A1", 56);

		// determine the highest sequence number
		int lHighestVersion = lImportFromStandversion.getStand().determineHighestVersionOfAllMyStandversions();
		if (lHighestVersion == 0) lHighestVersion = 1;

		// create new standversion
		Standversion lNewStandversion = new Standversion( lImportFromStandversion.getStand() );

		// initialize the new standversion
		lNewStandversion.setReplaceDate( new GregorianCalendar() );
		lNewStandversion.setVersion( lHighestVersion + 1);
		lNewStandversion.setPricePerUnit( lImportFromStandversion.getPricePerUnit());

		// copy the assigns from the original to the new 
		int lCnt = 0;
		for (Standassign lImportFromStandassign : new ArrayList<Standassign>( lImportFromStandversion.getStandassignsWhereIAmStandversion() ) ) // The "new ArrayList" forces the whole collection to be read, not lazy loaded. Otherwise this will result in a concurrent modification exception.
		{
			// progress 
			lCnt++;
			System.out.println( lCnt + "/" + lImportFromStandversion.getStandassignsWhereIAmStandversion().size());

			// clone
			Standassign lNewStandassign = lImportFromStandassign.cloneShallow();

			// initialize
			lNewStandassign.setStandversion(lNewStandversion);
			lNewStandassign.setChangeIndicator(false);
		}

		// save
		lEntityManager.clear();
		lEntityManager.getTransaction().begin();
		lEntityManager.merge(lNewStandversion);
		lEntityManager.getTransaction().commit();
		System.out.println("done");		
		
		lEntityManager.close();		
		lEntityManagerFactory.close();
	}

}
